Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UINewVMWzd.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UINewVMWzd.cpp	(revision 28226)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UINewVMWzd.cpp	(revision 28227)
@@ -693,6 +693,12 @@
     {
         m_Machine.SetKeyboardHidType(KKeyboardHidType_USBKeyboard);
-        m_Machine.SetPointingHidType(type.GetRecommendedUsbTablet()  ?
-                                     KPointingHidType_USBTablet : KPointingHidType_USBMouse);
+        m_Machine.SetPointingHidType(KPointingHidType_USBMouse);
+        if (!usbController.isNull())
+            usbController.SetEnabled(true);
+    }
+
+    if (type.GetRecommendedUsbTablet())
+    {
+        m_Machine.SetPointingHidType(KPointingHidType_USBTablet);
         if (!usbController.isNull())
             usbController.SetEnabled(true);
Index: /trunk/src/VBox/Main/Global.cpp
===================================================================
--- /trunk/src/VBox/Main/Global.cpp	(revision 28226)
+++ /trunk/src/VBox/Main/Global.cpp	(revision 28227)
@@ -100,44 +100,44 @@
        128,   4,  4 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_Linux26,         "Linux 2.6",
-      VBOXOSTYPE_Linux26,         VBOXOSHINT_RTCUTC,
+      VBOXOSTYPE_Linux26,         VBOXOSHINT_RTCUTC | VBOXOSHINT_USBTABLET,
        256,   4,  8 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_Linux26_64,      "Linux 2.6 (64 bit)",
-      VBOXOSTYPE_Linux26_x64,     VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC | VBOXOSHINT_RTCUTC,
+      VBOXOSTYPE_Linux26_x64,     VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC | VBOXOSHINT_RTCUTC | VBOXOSHINT_USBTABLET,
        256,   4,  8 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_ArchLinux,       "Arch Linux",
-      VBOXOSTYPE_ArchLinux,       VBOXOSHINT_RTCUTC,
+      VBOXOSTYPE_ArchLinux,       VBOXOSHINT_RTCUTC | VBOXOSHINT_USBTABLET,
        256,  12,  8 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_ArchLinux_64,    "Arch Linux (64 bit)",
-      VBOXOSTYPE_ArchLinux_x64,   VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC | VBOXOSHINT_RTCUTC,
+      VBOXOSTYPE_ArchLinux_x64,   VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC | VBOXOSHINT_RTCUTC | VBOXOSHINT_USBTABLET,
        256,  12,  8 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_Debian,          "Debian",
-      VBOXOSTYPE_Debian,          VBOXOSHINT_RTCUTC,
+      VBOXOSTYPE_Debian,          VBOXOSHINT_RTCUTC | VBOXOSHINT_USBTABLET,
        256,  12,  8 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_Debian_64,       "Debian (64 bit)",
-      VBOXOSTYPE_Debian_x64,      VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC | VBOXOSHINT_RTCUTC,
+      VBOXOSTYPE_Debian_x64,      VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC | VBOXOSHINT_RTCUTC | VBOXOSHINT_USBTABLET,
        256,  12,  8 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_OpenSUSE,        "openSUSE",
-      VBOXOSTYPE_OpenSUSE,        VBOXOSHINT_RTCUTC,
+      VBOXOSTYPE_OpenSUSE,        VBOXOSHINT_RTCUTC | VBOXOSHINT_USBTABLET,
        256,  12,  8 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_OpenSUSE_64,     "openSUSE (64 bit)",
-      VBOXOSTYPE_OpenSUSE_x64,    VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC | VBOXOSHINT_RTCUTC,
+      VBOXOSTYPE_OpenSUSE_x64,    VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC | VBOXOSHINT_RTCUTC | VBOXOSHINT_USBTABLET,
        256,  12,  8 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_Fedora,          "Fedora",
-      VBOXOSTYPE_FedoraCore,      VBOXOSHINT_RTCUTC,
+      VBOXOSTYPE_FedoraCore,      VBOXOSHINT_RTCUTC | VBOXOSHINT_USBTABLET,
        384,  12,  8 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_Fedora_64,       "Fedora (64 bit)",
-      VBOXOSTYPE_FedoraCore_x64,  VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC | VBOXOSHINT_RTCUTC,
+      VBOXOSTYPE_FedoraCore_x64,  VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC | VBOXOSHINT_RTCUTC | VBOXOSHINT_USBTABLET,
        384,  12,  8 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_Gentoo,          "Gentoo",
-      VBOXOSTYPE_Gentoo,          VBOXOSHINT_RTCUTC,
+      VBOXOSTYPE_Gentoo,          VBOXOSHINT_RTCUTC | VBOXOSHINT_USBTABLET,
        256,  12,  8 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_Gentoo_64,       "Gentoo (64 bit)",
-      VBOXOSTYPE_Gentoo_x64,      VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC | VBOXOSHINT_RTCUTC,
+      VBOXOSTYPE_Gentoo_x64,      VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC | VBOXOSHINT_RTCUTC | VBOXOSHINT_USBTABLET,
        256,  12,  8 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_Mandriva,        "Mandriva",
-      VBOXOSTYPE_Mandriva,        VBOXOSHINT_RTCUTC,
+      VBOXOSTYPE_Mandriva,        VBOXOSHINT_RTCUTC | VBOXOSHINT_USBTABLET,
        256,  12,  8 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_Mandriva_64,     "Mandriva (64 bit)",
-      VBOXOSTYPE_Mandriva_x64,    VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC | VBOXOSHINT_RTCUTC,
+      VBOXOSTYPE_Mandriva_x64,    VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC | VBOXOSHINT_RTCUTC | VBOXOSHINT_USBTABLET,
        256,  12,  8 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_RedHat,          "Red Hat",
@@ -148,14 +148,14 @@
        384,  12,  8 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_Turbolinux,      "Turbolinux",
-      VBOXOSTYPE_Turbolinux,      VBOXOSHINT_RTCUTC,
+      VBOXOSTYPE_Turbolinux,      VBOXOSHINT_RTCUTC | VBOXOSHINT_USBTABLET,
        384,  12,  8 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_Turbolinux,      "Turbolinux",
-      VBOXOSTYPE_Turbolinux_x64,  VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC | VBOXOSHINT_RTCUTC,
+      VBOXOSTYPE_Turbolinux_x64,  VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC | VBOXOSHINT_RTCUTC | VBOXOSHINT_USBTABLET,
        384,  12,  8 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_Ubuntu,          "Ubuntu",
-      VBOXOSTYPE_Ubuntu,          VBOXOSHINT_RTCUTC,
+      VBOXOSTYPE_Ubuntu,          VBOXOSHINT_RTCUTC | VBOXOSHINT_USBTABLET,
        384,  12,  8 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_Ubuntu_64,       "Ubuntu (64 bit)",
-      VBOXOSTYPE_Ubuntu_x64,      VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC | VBOXOSHINT_RTCUTC,
+      VBOXOSTYPE_Ubuntu_x64,      VBOXOSHINT_64BIT | VBOXOSHINT_HWVIRTEX | VBOXOSHINT_IOAPIC | VBOXOSHINT_RTCUTC | VBOXOSHINT_USBTABLET,
        384,  12,  8 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_Xandros,         "Xandros",
@@ -172,5 +172,5 @@
        384,  12,  8 * _1K, NetworkAdapterType_I82540EM, 0, StorageControllerType_PIIX4 },
     { "Linux",   "Linux",             SchemaDefs_OSTypeId_Linux,           "Other Linux",
-      VBOXOSTYPE_Linux,           VBOXOSHINT_RTCUTC,
+      VBOXOSTYPE_Linux,           VBOXOSHINT_RTCUTC | VBOXOSHINT_USBTABLET,
        256,  12,  8 * _1K, NetworkAdapterType_Am79C973, 0, StorageControllerType_PIIX4 },
     { "Solaris", "Solaris",           SchemaDefs_OSTypeId_Solaris,         "Solaris",
Index: /trunk/src/VBox/Main/idl/VirtualBox.xidl
===================================================================
--- /trunk/src/VBox/Main/idl/VirtualBox.xidl	(revision 28226)
+++ /trunk/src/VBox/Main/idl/VirtualBox.xidl	(revision 28227)
@@ -8344,5 +8344,5 @@
 
     <attribute name="recommendedUsbTablet" type="boolean" readonly="yes">
-      <desc>Returns @c true if using USB Tablet recommended (only relevant if using USB HIDs).</desc>
+      <desc>Returns @c true if using a USB Tablet is recommended.</desc>
     </attribute>
 